#include "common.ch"
#include "os.ch"
#define CRLF CHR(13)+CHR(10)

#PRAGMA LIBRARY("ASCOM10.LIB")


PROCEDURE Main(strComputer,cUser,cPassword)
LOCAL objWMIServices
LOCAL colItems
LOCAL cText
LOCAL cName
LOCAL bCollBlock
LOCAL i,iMax
LOCAL j,jMax
LOCAL aitem := {}
LOCAL aProp := {;
"CPUScore",;
"MemoryScore",;
"GraphicsScore",;
"D3DScore",;
"DiskScore",;
"WinSPRLevel" }

* "TimeTaken",;
* "WinSATAssessmentState",;


DEFAULT strComputer TO "Localhost"
DEFAULT cUser       TO "Administrator"
DEFAULT cPassword   TO ""

   CLS

   SET ALTER TO Win32_WinSAT.TXT
   SET ALTER ON

   IF VAL( OS(OS_VERSION) ) > 6
      IF strComputer == "Localhost"
         objWMIServices  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2")
      ELSE
         IF EMPTY(cPassword)
            MSGBOX("Need Password")
            QUIT
         ELSE
            objWMIServices  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2",strComputer+"\"+cUser,cPassword)
         ENDIF
      ENDIF
   ELSE
      objWMIServices  := GetObject("WinMgmts:{impersonationLevel=impersonate}\\"+strComputer+"\Root\CIMv2") 
   ENDIF

   colItems       := objWMIServices:ExecQuery("select * from Win32_WinSAT",,48)
   bCollBlock     := {|oService,n| AADD(aItem,{ n,;
     oService:getProperty("CPUScore"),;
     oService:getProperty("MemoryScore"),;
     oService:getProperty("GraphicsScore"),;
     oService:getProperty("D3DScore"),;
     oService:getProperty("DiskScore"),;
     oService:getProperty("WinSPRLevel") })}

*     oService:getProperty("TimeTaken"),;
*     oService:getProperty("WinSATAssessmentState"),;

   ComEvalCollection(colItems, bCollBlock )

   IF LEN(aItem) > 0
      ? "Win32_WinSAT"
      jMax := LEN(aItem)
      iMax := LEN(aItem[1])
      FOR j := 1 TO jMax
         ?"*****************************************************************************"
         FOR i := 1 TO iMax-1
            ? SUBSTR(aProp[i]+SPACE(40),1,40)+":",aItem[j,i+1]
         NEXT
         ?"*****************************************************************************"
      NEXT
   ELSE
      MSGBOX("no Property found ?")
   ENDIF

   SET ALTER OFF
   SET ALTER TO

   Runshell("Win32_WinSAT.TXT","Notepad.exe",.T.)

RETURN
